/*
 Do not modify, auto-generated by script

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   foreach_stmt.cpp
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#include <uhdm/foreach_stmt.h>
#include <uhdm/ElaboratorListener.h>
#include <uhdm/ElaboratorListener.h>
#include <uhdm/Serializer.h>
#include <uhdm/stmt.h>
#include <uhdm/variables.h>
#include <uhdm/variables_operation_group.h>


namespace UHDM {
const BaseClass* foreach_stmt::GetByVpiName(std::string_view name) const {
  if ((variable_ != nullptr) && (variable_->VpiName().compare(name) == 0)) {
    return variable_;
  }
  if (vpiLoopVars_ != nullptr) {
    for (const BaseClass *ref : *vpiLoopVars_) {
      if (ref->VpiName().compare(name) == 0) return ref;
    }
  }
  if ((vpiStmt_ != nullptr) && (vpiStmt_->VpiName().compare(name) == 0)) {
    return vpiStmt_;
  }
  return basetype_t::GetByVpiName(name);
}

std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> foreach_stmt::GetByVpiType(int32_t type) const {
  switch (type) {
    case vpiLoopVars: return std::make_tuple(nullptr, uhdmvpiLoopVars, (const std::vector<const BaseClass*>*)vpiLoopVars_);
    case vpiStmt: return std::make_tuple(vpiStmt_, static_cast<UHDM_OBJECT_TYPE>(0), nullptr);
    case vpiVariables: return std::make_tuple(variable_, static_cast<UHDM_OBJECT_TYPE>(0), nullptr);
  }
  return basetype_t::GetByVpiType(type);
}

foreach_stmt::vpi_property_value_t foreach_stmt::GetVpiPropertyValue(int32_t property) const {
  switch (property) {
    case vpiType: return vpi_property_value_t(VpiType());
  }
  return basetype_t::GetVpiPropertyValue(property);
}

void foreach_stmt::DeepCopy(foreach_stmt* clone, BaseClass* parent, CloneContext* context) const {
  [[maybe_unused]] ElaboratorContext* const elaboratorContext = clonecontext_cast<ElaboratorContext*>(context);
  elaboratorContext->m_elaborator.enterForeach_stmt(clone, nullptr);
  basetype_t::DeepCopy(clone, parent, context);
  if (auto obj = Variable()) clone->Variable(obj->DeepClone(clone, context));
  if (auto vec = VpiLoopVars()) {
    auto clone_vec = context->m_serializer->MakeAnyVec();
    clone->VpiLoopVars(clone_vec);
    for (auto obj : *vec) {
      clone_vec->push_back(obj->DeepClone(clone, context));
    }
  }
  if (auto obj = VpiStmt()) clone->VpiStmt(obj->DeepClone(clone, context));
  elaboratorContext->m_elaborator.leaveForeach_stmt(clone, nullptr);
}

foreach_stmt* foreach_stmt::DeepClone(BaseClass* parent, CloneContext* context) const {
  foreach_stmt* const clone = context->m_serializer->MakeForeach_stmt();
  const uint32_t id = clone->UhdmId();
  *clone = *this;
  clone->UhdmId(id);
  DeepCopy(clone, parent, context);
  return clone;
}

int32_t foreach_stmt::Compare(const BaseClass *other, CompareContext* context) const {
  int32_t r = 0;
  if (!context->m_visited.insert(this).second) return r;
  if ((r = basetype_t::Compare(other, context)) != 0) return r;

  const thistype_t *const lhs = this;
  const thistype_t *const rhs = (const thistype_t *)other;

  if ((r = SafeCompare(lhs->Variable(), rhs->Variable(), context)) != 0) return r;
  if ((r = SafeCompare(lhs, lhs->VpiLoopVars(), rhs, rhs->VpiLoopVars(), context)) != 0) return r;
  if ((r = SafeCompare(lhs->VpiStmt(), rhs->VpiStmt(), context)) != 0) return r;
  return r;
}

}  // namespace UHDM
