/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   indexed_part_select.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_INDEXED_PART_SELECT_H
#define UHDM_INDEXED_PART_SELECT_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/ref_obj.h>




namespace UHDM {
class expr;

class indexed_part_select final : public ref_obj {
  UHDM_IMPLEMENT_RTTI(indexed_part_select, ref_obj)
public:
  // Implicit constructor used to initialize all members,
  // comment: indexed_part_select();
  virtual ~indexed_part_select() final = default;

  bool VpiConstantSelect() const { return vpiConstantSelect_; }
  bool VpiConstantSelect(bool data) {
    vpiConstantSelect_ = data;
    return true;
  }

  int32_t VpiIndexedPartSelectType() const { return vpiIndexedPartSelectType_; }
  bool VpiIndexedPartSelectType(int32_t data) {
    vpiIndexedPartSelectType_ = data;
    return true;
  }

  expr* Base_expr()  { return base_expr_; }
  const expr* Base_expr() const { return base_expr_; }
  template <typename T>
  T* Base_expr() {
    return (base_expr_ == nullptr) ? nullptr : any_cast<T*>(base_expr_);
  }
  template <typename T>
  const T* Base_expr() const {
    return (base_expr_ == nullptr) ? nullptr : any_cast<const T*>(base_expr_);
  }
  bool Base_expr(expr* data) {
    base_expr_ = data;
    return true;
  }

  expr* Width_expr()  { return width_expr_; }
  const expr* Width_expr() const { return width_expr_; }
  template <typename T>
  T* Width_expr() {
    return (width_expr_ == nullptr) ? nullptr : any_cast<T*>(width_expr_);
  }
  template <typename T>
  const T* Width_expr() const {
    return (width_expr_ == nullptr) ? nullptr : any_cast<const T*>(width_expr_);
  }
  bool Width_expr(expr* data) {
    width_expr_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiIndexedPartSelect; }

  virtual indexed_part_select* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmindexed_part_select; }

protected:
  void DeepCopy(indexed_part_select* clone, BaseClass* parent, CloneContext* context) const;

private:
  bool vpiConstantSelect_ = false;

  int32_t vpiIndexedPartSelectType_ = 0;

  expr* base_expr_ = nullptr;

  expr* width_expr_ = nullptr;
};


typedef FactoryT<indexed_part_select> indexed_part_selectFactory;


typedef FactoryT<std::vector<indexed_part_select *>> VectorOfindexed_part_selectFactory;

}  // namespace UHDM

#endif
