/*
 Do not modify, auto-generated by classes.py

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   property_decl.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PROPERTY_DECL_H
#define UHDM_PROPERTY_DECL_H

#include <uhdm/sv_vpi_user.h>
#include <uhdm/uhdm_vpi_user.h>

#include <uhdm/containers.h>
#include <uhdm/BaseClass.h>




namespace UHDM {
class property_spec;

class property_decl final : public BaseClass {
  UHDM_IMPLEMENT_RTTI(property_decl, BaseClass)
public:
  // Implicit constructor used to initialize all members,
  // comment: property_decl();
  virtual ~property_decl() final = default;

  virtual bool VpiName(std::string_view data) final;
  virtual std::string_view VpiName() const final;

  bool VpiFullName(std::string_view data);
  std::string_view VpiFullName() const;

  VectorOfattribute* Attributes() const { return attributes_; }
  bool Attributes(VectorOfattribute* data) {
    attributes_ = data;
    return true;
  }

  VectorOfprop_formal_decl* Prop_formal_decls() const { return prop_formal_decls_; }
  bool Prop_formal_decls(VectorOfprop_formal_decl* data) {
    prop_formal_decls_ = data;
    return true;
  }

  VectorOfvariables* Variables() const { return variables_; }
  bool Variables(VectorOfvariables* data) {
    variables_ = data;
    return true;
  }

  property_spec* Property_spec()  { return property_spec_; }
  const property_spec* Property_spec() const { return property_spec_; }
  template <typename T>
  T* Property_spec() {
    return (property_spec_ == nullptr) ? nullptr : any_cast<T*>(property_spec_);
  }
  template <typename T>
  const T* Property_spec() const {
    return (property_spec_ == nullptr) ? nullptr : any_cast<const T*>(property_spec_);
  }
  bool Property_spec(property_spec* data) {
    property_spec_ = data;
    return true;
  }

  virtual uint32_t VpiType() const final { return vpiPropertyDecl; }

  virtual property_decl* DeepClone(BaseClass* parent, CloneContext* context) const override;

  virtual const BaseClass* GetByVpiName(std::string_view name) const override;

  virtual std::tuple<const BaseClass*, UHDM_OBJECT_TYPE, const std::vector<const BaseClass*>*> GetByVpiType(int32_t type) const override;

  virtual vpi_property_value_t GetVpiPropertyValue(int32_t property) const override;

  virtual int32_t Compare(const BaseClass* other, CompareContext* context) const override;

  virtual  UHDM_OBJECT_TYPE UhdmType() const final { return UHDM_OBJECT_TYPE::uhdmproperty_decl; }

protected:
  void DeepCopy(property_decl* clone, BaseClass* parent, CloneContext* context) const;

private:
  SymbolId vpiName_;

  SymbolId vpiFullName_;

  VectorOfattribute* attributes_ = nullptr;

  VectorOfprop_formal_decl* prop_formal_decls_ = nullptr;

  VectorOfvariables* variables_ = nullptr;

  property_spec* property_spec_ = nullptr;
};


typedef FactoryT<property_decl> property_declFactory;


typedef FactoryT<std::vector<property_decl *>> VectorOfproperty_declFactory;

}  // namespace UHDM

#endif
